//   RW Moveit
// ==============
// Motion-Scripting Production Tools Library
// -Part of the RW Foundations suite of libraries

// Filename: ./include/action/moveit.hpp
// -Declarations of the baseline RW Moveit sub-library

#pragma once

#include "incls_all.hpp"

namespace rw::action {

//------------------------------------------------------------------------------
/**
 */
class Moveit_b : public RW {
 public:
  Moveit_b();                                    // default ctor
  explicit Moveit_b(std::string const& handle);  // tag-parm'd ctor
};

//------------------------------------------------------------------------------
/**
 */
class Moveit : public Moveit_b {
 public:
  Moveit();                                    // default ctor
  explicit Moveit(std::string const& handle);  // tag-parm'd ctor

  inline auto bones() const -> Bones& { return bones_; }

 private:
  unique_ptr<Bones_b> _bones_{make_unique<Bones_b>("moveit_bones")};

  Bones& bones_{reference_to<Bones>(_bones_.get())};
};

}  // namespace rw::action

//    --=^=--

// "______"

// rw_action_lib.v220521
// Copyright (2022)
// License MIT (Expat) https://opensource.org/licenses/MIT
