//   RW Arigato
// ==============
// aka 'Robowaifu' - The Humanoid Female Robot Companion Library
// -Part of the RW Foundations suite of libraries

// Filename: ./include/arigato/arigato.hpp
// -Declarations of the baseline RW Arigato library

#pragma once

#include "incls_all.hpp"

namespace rw::arigato {

//------------------------------------------------------------------------------
/**
 */
class Arigato_b : public RW {
 public:
  Arigato_b();                                            // default ctor
  explicit Arigato_b(std::string const& handle);          // tag-parm'd ctor
  Arigato_b(std::string const& handle, Type const type);  //  "
};

//------------------------------------------------------------------------------
/**
 */
class Arigato : public Arigato_b {
 public:
  Arigato();                                            // default ctor
  explicit Arigato(std::string const& handle);          // tag-parm'd ctor
  Arigato(std::string const& handle, Type const type);  //  "
  virtual ~Arigato();

  virtual auto do_preflight() -> bool;

  inline auto animeyes() const -> Animeyes& { return animeyes_; }
  inline auto atashi() const -> Atashi& { return atashi_; }
  inline auto bones() const -> Bones& { return bones_; }
  inline auto curator() const -> Curator& { return curator_; }
  inline auto dollhouse() const -> Dollhouse& { return dollhouse_; }
  inline auto electro() const -> Electro& { return electro_; }
  inline auto face() const -> Face& { return face_; }
  inline auto gears() const -> Gears& { return gears_; }
  inline auto hand() const -> Hand& { return hand_; }
  inline auto hearsay() const -> Hearsay& { return hearsay_; }
  inline auto meido() const -> Meido& { return meido_; }
  inline auto shell() const -> Shell& { return shell_; }

 private:
  unique_ptr<Animeyes_b> _animeyes_{
      make_unique<Animeyes_b>("arigato_animeyes")};
  unique_ptr<Atashi_b>    _atashi_{make_unique<Atashi_b>("arigato_atashi")};
  unique_ptr<Bones_b>     _bones_{make_unique<Bones_b>("arigato_bones")};
  unique_ptr<Curator_b>   _curator_{make_unique<Curator_b>("arigato_curator")};
  unique_ptr<Dollhouse_b> _dollhouse_{
      make_unique<Dollhouse_b>("arigato_dollhouse")};
  unique_ptr<Electro_b> _electro_{make_unique<Electro_b>("arigato_electro")};
  unique_ptr<Face_b>    _face_{make_unique<Face_b>("arigato_face")};
  unique_ptr<Gears_b>   _gears_{make_unique<Gears_b>("arigato_gears")};
  unique_ptr<Hand_b>    _hand_{make_unique<Hand_b>("arigato_hand")};
  unique_ptr<Hearsay_b> _hearsay_{make_unique<Hearsay_b>("arigato_hearsay")};
  unique_ptr<Meido_b>   _meido_{make_unique<Meido_b>("arigato_meido")};
  unique_ptr<Shell_b>   _shell_{make_unique<Shell_b>("arigato_shell")};

  Animeyes&  animeyes_{reference_to<Animeyes>(_animeyes_.get())};
  Atashi&    atashi_{reference_to<Atashi>(_atashi_.get())};
  Bones&     bones_{reference_to<Bones>(_bones_.get())};
  Curator&   curator_{reference_to<Curator>(_curator_.get())};
  Dollhouse& dollhouse_{reference_to<Dollhouse>(_dollhouse_.get())};
  Electro&   electro_{reference_to<Electro>(_electro_.get())};
  Face&      face_{reference_to<Face>(_face_.get())};
  Gears&     gears_{reference_to<Gears>(_gears_.get())};
  Hand&      hand_{reference_to<Hand>(_hand_.get())};
  Hearsay&   hearsay_{reference_to<Hearsay>(_hearsay_.get())};
  Meido&     meido_{reference_to<Meido>(_meido_.get())};
  Shell&     shell_{reference_to<Shell>(_shell_.get())};
};

}  // namespace rw::arigato

//    --=^=--

// "I only wish I could find a really cute one just lying around somewhere."

// rw_arigato_lib.v220521
// Copyright (2022)
// License MIT (Expat) https://opensource.org/licenses/MIT
