//   RW Sumomo
// ==============
// Demonstration of a Chibitsu-grade robowaifu
// -Part of the RW Foundations suite of libraries

// Filename: ./src/chibitsu/sumomo.cpp
// -Definitions of the baseline RW Sumomo project subsystem

#include "incls_all.hpp"

namespace rw::chibitsu {

//------------------------------------------------------------------------------
Sumomo_b::Sumomo_b() : Sumomo_b{"sumomo_b_obj"} {}

//------------------------------------------------------------------------------
Sumomo_b::Sumomo_b(std::string const& handle) : Chibitsu{handle} {
  stamp("Sumomo_b()");
}

//------------------------------------------------------------------------------
Sumomo::Sumomo() : Sumomo{"sumomo_obj"} {}

//------------------------------------------------------------------------------
Sumomo::Sumomo(std::string const& handle) : Sumomo_b{handle} {
  stamp("Sumomo()");
}

//------------------------------------------------------------------------------
auto Sumomo::do_preflight() -> bool {
  stamp("do_preflight()");

  // TODO:
  // do actual initialization here. eg, turn off embedded object's unneeded
  // members, ensure filesets are available & ready, connections are working,
  // etc., etc., etc.  :^)
  //

  // TODO: create an integrated systems/status terminal suite. mv this there.
  // -status msgs into one terminal, diag spew into another.
  // STATUS:
  cout << ' ' << hdl() << " checks out A-OK!\n";
  return true;  // TEMP:
}

}  // namespace rw::chibitsu

//    --=^=--

// "EMERGENCY, EMERGENCY! THIS IS A CRISIS SITUATION!!"

// rw_chibitsu_lib.v220521
// Copyright (2022)
// License MIT (Expat) https://opensource.org/licenses/MIT
